﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using HeuristicLab.Services.Authentication.DataTransfer;

namespace HeuristicLab.Services.Authentication
{
    [ServiceContract]
    public interface IClientService
    {
        #region Client Methods
        [OperationContract]
        Client GetClient(Guid id);
        [OperationContract]
        IEnumerable<Client> GetClients();
        [OperationContract]
        Guid AddClient(Client dto);
        [OperationContract]
        bool UpdateClient(Client dto);
        [OperationContract]
        bool DeleteClient(Client dto);
        #endregion

        #region ResourceGroup Methods
        [OperationContract]
        ResourceGroup GetResourceGroup(Guid id);
        [OperationContract]
        IEnumerable<ResourceGroup> GetResourceGroups();
        [OperationContract]
        Guid AddResourceGroup(ResourceGroup dto);
        [OperationContract]
        bool UpdateResourceGroup(ResourceGroup dto);
        [OperationContract]
        bool DeleteResourceGroup(ResourceGroup id);
        #endregion

        #region Additional Methods
        [OperationContract]
        IEnumerable<Resource> GetMembers(Guid id);
        [OperationContract]
        IEnumerable<Resource> GetRootResources();
        #endregion
    }
}
